package com.jotuntech.sketcher.client.command;

import java.nio.ByteBuffer;
import java.util.Deque;

import com.jotuntech.sketcher.client.Client;
import com.jotuntech.sketcher.client.Command;
import com.jotuntech.sketcher.client.Connection;
import com.jotuntech.sketcher.common.UndoEntry;
import com.jotuntech.sketcher.common.User;

public class UndoCommand implements Command {

	public int perform(Client client, User user) {
		if(user.isViewer()) {
			return Connection.SEND_NONE;
		}

		Deque<UndoEntry> undoDeque = user.getUndoDeque();
		if(undoDeque.size() == 0) {
			return Connection.SEND_NONE;
		}
		UndoEntry undoEntry = undoDeque.removeFirst();
		undoEntry.getLayer().undo(undoEntry.getUndoData());
		return Connection.SEND_OTHERS;
	}

	public void decode(ByteBuffer in) {

	}

	public void encode(ByteBuffer out) {

	}
}
