package com.jotuntech.sketcher.client.voice.aec;

/* Recursive single pole IIR Infinite Impulse response filter
 * Coefficients calculated with
 * http://www.dsptutor.freeuk.com/IIRFilterDesign/IIRFiltDes102.html
 */

public class IIR1 {
	private final static float a0 = 0.105831884f;
	private final static float a1 = -0.105831884f;
	private final static float b1 = 0.78833646f;

	private float x, y;

	float highpass(float in) {
		// Chebyshev IIR filter, Filter type: HP
		// Passband: 3700 - 4000.0 Hz
		// Passband ripple: 1.5 dB, Order: 1
		float out = a0 * in + a1 * x + b1 * y;
		x = in;
		y = out;
		return out;
	}
}